"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _flowRuntime = _interopRequireDefault(require("flow-runtime"));

var _recursiveReaddir = _interopRequireDefault(require("recursive-readdir"));

var _nodeSass = _interopRequireWildcard(require("node-sass"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var path = require('path');

var fileSystem = require('fs');

var NodeSassRenderCallbackResultType = _flowRuntime["default"].tdz(function () {
  return _nodeSass.NodeSassRenderCallbackResultType;
});

var fileExtensionList = new Set(['.css', '.scss', '.sass']);
var excludeFolderList = new Set(['node_modules', '.git']);

var FileStatsType = _flowRuntime["default"].type("FileStatsType", _flowRuntime["default"].object(_flowRuntime["default"].property("isDirectory", _flowRuntime["default"]["function"](_flowRuntime["default"]["return"](_flowRuntime["default"]["boolean"]())))));

function fileExclude(pathToFile, stats) {
  var _pathToFileType = _flowRuntime["default"].string();

  var _statsType = FileStatsType;

  var _returnType = _flowRuntime["default"]["return"](_flowRuntime["default"]["boolean"]());

  _flowRuntime["default"].param("pathToFile", _pathToFileType).assert(pathToFile);

  _flowRuntime["default"].param("stats", _statsType).assert(stats);

  if (stats.isDirectory()) {
    return _returnType.assert(false);
  }

  var filePathChunkList = new Set(pathToFile.split(path.sep)); // eslint-disable-next-line no-loops/no-loops

  var _iterator = _createForOfIteratorHelper(excludeFolderList),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var excludeFolder = _step.value;

      if (filePathChunkList.has(excludeFolder)) {
        return _returnType.assert(true);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  var extname = path.extname(pathToFile);
  return _returnType.assert(!fileExtensionList.has(extname));
}

_flowRuntime["default"].annotate(fileExclude, _flowRuntime["default"]["function"](_flowRuntime["default"].param("pathToFile", _flowRuntime["default"].string()), _flowRuntime["default"].param("stats", FileStatsType), _flowRuntime["default"]["return"](_flowRuntime["default"]["boolean"]())));

var classListReplaceValue = '{{class-list}}';
var templateWrapper = "// @flow strict\n/* This file is automatically generated by css-module-flow-loader */\ndeclare module.exports: {|\n".concat(classListReplaceValue, "\n|};\n");

function rawClassNameToFlowProperty(rawClassName) {
  var _rawClassNameType = _flowRuntime["default"].string();

  var _returnType2 = _flowRuntime["default"]["return"](_flowRuntime["default"].string());

  _flowRuntime["default"].param("rawClassName", _rawClassNameType).assert(rawClassName);

  var className = rawClassName.replace(/[\s.:{]/g, '');
  return _returnType2.assert("    +'".concat(className, "': string;"));
}

_flowRuntime["default"].annotate(rawClassNameToFlowProperty, _flowRuntime["default"]["function"](_flowRuntime["default"].param("rawClassName", _flowRuntime["default"].string()), _flowRuntime["default"]["return"](_flowRuntime["default"].string())));

function getFlowTypeFileContent(allRawClassNameList) {
  var _allRawClassNameListType = _flowRuntime["default"].array(_flowRuntime["default"].string());

  var _returnType3 = _flowRuntime["default"]["return"](_flowRuntime["default"].string());

  _flowRuntime["default"].param("allRawClassNameList", _allRawClassNameListType).assert(allRawClassNameList);

  var allClassNameList = _toConsumableArray(new Set(allRawClassNameList)).map(rawClassNameToFlowProperty);

  var uniqClassNameList = _toConsumableArray(new Set(allClassNameList));

  return _returnType3.assert(templateWrapper.replace(classListReplaceValue, uniqClassNameList.join('\n')));
}

_flowRuntime["default"].annotate(getFlowTypeFileContent, _flowRuntime["default"]["function"](_flowRuntime["default"].param("allRawClassNameList", _flowRuntime["default"].array(_flowRuntime["default"].string())), _flowRuntime["default"]["return"](_flowRuntime["default"].string())));

function renderNodeSassCallback(sassRenderError, result) {
  var _sassRenderErrorType = _flowRuntime["default"].nullable(_flowRuntime["default"].ref("Error"));

  var _resultType = _flowRuntime["default"].nullable(_flowRuntime["default"].ref(NodeSassRenderCallbackResultType));

  _flowRuntime["default"].param("sassRenderError", _sassRenderErrorType).assert(sassRenderError);

  _flowRuntime["default"].param("result", _resultType).assert(result);

  if (sassRenderError || !result) {
    throw sassRenderError;
  }

  var allRawClassNameList = result.css.toString().match(/\.([_a-z]+[\w-_]*)[\s#,.:>{]*/gim);

  if (!allRawClassNameList) {
    return;
  }

  var filePathFlowTyped = result.stats.entry + '.flow';

  function fileWriteCallback(fileWriteError) {
    var _fileWriteErrorType = _flowRuntime["default"].nullable(_flowRuntime["default"].ref("Error"));

    _flowRuntime["default"].param("fileWriteError", _fileWriteErrorType).assert(fileWriteError);

    if (fileWriteError) {
      throw fileWriteError;
    }

    console.log('[css-module-flow-loader]:', filePathFlowTyped, 'has been updated.');
  }

  _flowRuntime["default"].annotate(fileWriteCallback, _flowRuntime["default"]["function"](_flowRuntime["default"].param("fileWriteError", _flowRuntime["default"].nullable(_flowRuntime["default"].ref("Error")))));

  fileSystem.writeFile(filePathFlowTyped, getFlowTypeFileContent(allRawClassNameList), fileWriteCallback);
}

_flowRuntime["default"].annotate(renderNodeSassCallback, _flowRuntime["default"]["function"](_flowRuntime["default"].param("sassRenderError", _flowRuntime["default"].nullable(_flowRuntime["default"].ref("Error"))), _flowRuntime["default"].param("result", _flowRuntime["default"].nullable(_flowRuntime["default"].ref(NodeSassRenderCallbackResultType)))));

function writeFlowType(pathToFile) {
  var _pathToFileType2 = _flowRuntime["default"].string();

  _flowRuntime["default"].param("pathToFile", _pathToFileType2).assert(pathToFile);

  _nodeSass["default"].render({
    file: pathToFile
  }, renderNodeSassCallback);
}

_flowRuntime["default"].annotate(writeFlowType, _flowRuntime["default"]["function"](_flowRuntime["default"].param("pathToFile", _flowRuntime["default"].string())));

module.exports = _flowRuntime["default"].annotate(function cssModuleFlowLoader(source) {
  var _sourceType = _flowRuntime["default"].string();

  var _returnType4 = _flowRuntime["default"]["return"](_flowRuntime["default"].string());

  _flowRuntime["default"].param("source", _sourceType).assert(source);

  var rootPathFolder = this.rootContext;

  _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var filePathList;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _recursiveReaddir["default"])(rootPathFolder, [fileExclude]);

          case 2:
            filePathList = _context.sent;
            filePathList.forEach(writeFlowType);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }))();

  return _returnType4.assert(source);
}, _flowRuntime["default"]["function"](_flowRuntime["default"].param("source", _flowRuntime["default"].string()), _flowRuntime["default"]["return"](_flowRuntime["default"].string())));
